# use module flask and flask-cors
# pip install flask
# pip install flask-cors
# documentation
# - http://flask-cors.readthedocs.org/en/latest/ manage problem Access-Control-Allow-Origin
# - http://flask.pocoo.org/

from flask import Flask
from flask import jsonify
from flask import json
from flask import request
from flask.ext.cors import CORS

app = Flask(__name__)
cors = CORS(app)

USERS = {'1': {'name':'nameA',
               'forname' : 'fornameA',
               'email' : 'nameA@domaine.fr'},
         '2': {'name':'nameB',
               'forname' : 'fornameB',
               'email' : 'nameB@domaine.fr'},
         '3': {'name':'nameC',
               'forname' : 'fornameC',
               'email' : 'nameC@domaine.fr'},
         '4': {'name':'nameD',
               'forname' : 'fornameD',
               'email' : 'nameD@domaine.fr'},
         '5': {'name':'nameE',
               'forname' : 'fornameE',
               'email' : 'nameE@domaine.fr'},
         '6': {'name':'nameF',
               'forname' : 'fornameF',
               'email' : 'nameF@domaine.fr'},
         '7': {'name':'nameG',
               'forname' : 'fornameG',
               'email' : 'nameG@domaine.fr'},
        }

TAGS = { '1': {'name':'tags A',
               'commentary':''},
         '2': {'name':'tags B',
               'commentary':''},
         '3': {'name':'tags C',
               'commentary':''},
         '4': {'name':'tags D',
               'commentary':''},
         '5': {'name':'tags E',
               'commentary':''},
         '6': {'name':'tags F',
               'commentary':''},
        }

@app.errorhandler(404)
def not_found(error=None, msg=''):
    message = {
            'status': 404,
            'message': 'Not Found: ' + msg,
    }
    resp = jsonify(message)
    resp.status_code = 404
    return resp

@app.route('/users/<userid>', methods = ['GET'])
def api_user(userid):
    if userid in USERS:
        return json.dumps([USERS[userid]])
    else:
        return not_found(error=None, msg="user %s" % userid)

@app.route('/users', methods = ['GET'])
def api_users():
    return json.dumps([dict(USERS[userid], id=userid) for userid in USERS.keys()])

@app.route('/setuser', methods = ['POST'])
def api_setuser():
    data = json.loads(request.data.decode())
    id = int(data['user']['id'])
    USERS[id] = data['user']
    print('set user %s' % id)
    return json.dumps([{"msg":"ok"}])

@app.route('/tags', methods = ['GET'])
def api_tags():
    return json.dumps([dict(USERS[userid], id=userid) for userid in USERS.keys()])

@app.route('/tag', methods = ['POST'])
def api_settag():
    data = json.loads(request.data.decode())
    id = int(data['tag']['id'])
    TAGS[id] = data['tag']
    print('set tag %s' % id)
    return json.dumps([{"msg":"ok"}])


if __name__ == '__main__':
    app.run()
